// python wrapper for vtkMPICompositeManager
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMPICompositeManager.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMPICompositeManager(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMPICompositeManager_ClassNew(); }

#ifndef DECLARED_PyvtkCompositeRenderManager_ClassNew
extern "C" { PyObject *PyvtkCompositeRenderManager_ClassNew(); }
#define DECLARED_PyvtkCompositeRenderManager_ClassNew
#endif

static const char *PyvtkMPICompositeManager_Doc =
  "vtkMPICompositeManager - Composites when running in MPI mode.\n\n"
  "Superclass: vtkCompositeRenderManager\n\n"
;

static PyTypeObject PyvtkMPICompositeManager_Tags_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsRenderingPython.vtkMPICompositeManager.Tags", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkMPICompositeManager_Tags_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkMPICompositeManager_Tags_Type, args, nullptr);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkMPICompositeManager_Tags_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkMPICompositeManager_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMPICompositeManager::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMPICompositeManager::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMPICompositeManager *tempr = vtkMPICompositeManager::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMPICompositeManager *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMPICompositeManager::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_InitializeRMIs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InitializeRMIs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InitializeRMIs();
    }
    else
    {
      op->vtkMPICompositeManager::InitializeRMIs();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_GetZBufferValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetZBufferValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    float tempr = (ap.IsBound() ?
      op->GetZBufferValue(temp0, temp1) :
      op->vtkMPICompositeManager::GetZBufferValue(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_GatherZBufferValueRMI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GatherZBufferValueRMI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->GatherZBufferValueRMI(temp0, temp1);
    }
    else
    {
      op->vtkMPICompositeManager::GatherZBufferValueRMI(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_StartRender(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartRender");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StartRender();
    }
    else
    {
      op->vtkMPICompositeManager::StartRender();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMPICompositeManager_ChooseBuffer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ChooseBuffer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPICompositeManager *op = static_cast<vtkMPICompositeManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->ChooseBuffer() :
      op->vtkMPICompositeManager::ChooseBuffer());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMPICompositeManager_Methods[] = {
  {"IsTypeOf", PyvtkMPICompositeManager_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMPICompositeManager_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMPICompositeManager_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMPICompositeManager\nC++: static vtkMPICompositeManager *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMPICompositeManager_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMPICompositeManager\nC++: vtkMPICompositeManager *NewInstance()\n\n"},
  {"InitializeRMIs", PyvtkMPICompositeManager_InitializeRMIs, METH_VARARGS,
   "V.InitializeRMIs()\nC++: virtual void InitializeRMIs() override;\n\nIf the user wants to handle the event loop, then they must call\nthis method to initialize the RMIs.\n"},
  {"GetZBufferValue", PyvtkMPICompositeManager_GetZBufferValue, METH_VARARGS,
   "V.GetZBufferValue(int, int) -> float\nC++: float GetZBufferValue(int x, int y)\n\nGet the z buffer value at a pixel.  GatherZBufferValue is an\ninternal method. Called only on root node.\n"},
  {"GatherZBufferValueRMI", PyvtkMPICompositeManager_GatherZBufferValueRMI, METH_VARARGS,
   "V.GatherZBufferValueRMI(int, int)\nC++: void GatherZBufferValueRMI(int x, int y)\n\nInternal method: called only on non-Root nodes.\n"},
  {"StartRender", PyvtkMPICompositeManager_StartRender, METH_VARARGS,
   "V.StartRender()\nC++: virtual void StartRender() override;\n\nOverridden to set the Image Size when ParallelRendering is off.\n"},
  {"ChooseBuffer", PyvtkMPICompositeManager_ChooseBuffer, METH_VARARGS,
   "V.ChooseBuffer() -> int\nC++: virtual int ChooseBuffer() override;\n\nSelect buffer to read from / render into. Overridden to choose\nthe back buffer only when the buffers haven;t been swapped yet.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMPICompositeManager_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsRenderingPython.vtkMPICompositeManager", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMPICompositeManager_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMPICompositeManager_StaticNew()
{
  return vtkMPICompositeManager::New();
}

PyObject *PyvtkMPICompositeManager_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMPICompositeManager_Type, PyvtkMPICompositeManager_Methods,
    "vtkMPICompositeManager",
 &PyvtkMPICompositeManager_StaticNew);

  PyTypeObject *pytype = &PyvtkMPICompositeManager_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCompositeRenderManager_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkMPICompositeManager_Tags_Type);
  PyvtkMPICompositeManager_Tags_Type.tp_new = nullptr;
  vtkPythonUtil::AddEnumToMap(&PyvtkMPICompositeManager_Tags_Type);

  o = (PyObject *)&PyvtkMPICompositeManager_Tags_Type;
  if (PyDict_SetItemString(d, "Tags", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkMPICompositeManager::Tags cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "GATHER_Z_RMI_TAG", vtkMPICompositeManager::GATHER_Z_RMI_TAG },
        { "Z_TAG", vtkMPICompositeManager::Z_TAG },
      };

    o = PyvtkMPICompositeManager_Tags_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMPICompositeManager(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMPICompositeManager_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMPICompositeManager", o) != 0)
  {
    Py_DECREF(o);
  }

}

