// python wrapper for vtkPSurfaceLICInterface
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPSurfaceLICInterface.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPSurfaceLICInterface(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPSurfaceLICInterface_ClassNew(); }

#ifndef DECLARED_PyvtkSurfaceLICInterface_ClassNew
extern "C" { PyObject *PyvtkSurfaceLICInterface_ClassNew(); }
#define DECLARED_PyvtkSurfaceLICInterface_ClassNew
#endif

static const char *PyvtkPSurfaceLICInterface_Doc =
  "vtkPSurfaceLICInterface - parallel parts of the vtkSurfaceLICInterface\n\n"
  "Superclass: vtkSurfaceLICInterface\n\n"
  "Parallel parts of the vtkSurfaceLICInterface, see that class for\n"
  "documentation.\n\n";


static PyObject *
PyvtkPSurfaceLICInterface_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPSurfaceLICInterface::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICInterface_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICInterface *op = static_cast<vtkPSurfaceLICInterface *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPSurfaceLICInterface::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICInterface_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPSurfaceLICInterface *tempr = vtkPSurfaceLICInterface::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICInterface_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICInterface *op = static_cast<vtkPSurfaceLICInterface *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPSurfaceLICInterface *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPSurfaceLICInterface::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICInterface_WriteTimerLog(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteTimerLog");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICInterface *op = static_cast<vtkPSurfaceLICInterface *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->WriteTimerLog(temp0);
    }
    else
    {
      op->vtkPSurfaceLICInterface::WriteTimerLog(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPSurfaceLICInterface_Methods[] = {
  {"IsTypeOf", PyvtkPSurfaceLICInterface_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPSurfaceLICInterface_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPSurfaceLICInterface_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPSurfaceLICInterface\nC++: static vtkPSurfaceLICInterface *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPSurfaceLICInterface_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPSurfaceLICInterface\nC++: vtkPSurfaceLICInterface *NewInstance()\n\n"},
  {"WriteTimerLog", PyvtkPSurfaceLICInterface_WriteTimerLog, METH_VARARGS,
   "V.WriteTimerLog(string)\nC++: virtual void WriteTimerLog(const char *fileName) override;\n\nMethods used for parallel benchmarks. Use cmake to define\nvtkSurfaceLICInterfaceTIME to enable benchmarks. During each\nupdate timing information is stored, it can be written to disk by\ncalling WriteLog.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPSurfaceLICInterface_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingParallelLICPython.vtkPSurfaceLICInterface", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPSurfaceLICInterface_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPSurfaceLICInterface_StaticNew()
{
  return vtkPSurfaceLICInterface::New();
}

PyObject *PyvtkPSurfaceLICInterface_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPSurfaceLICInterface_Type, PyvtkPSurfaceLICInterface_Methods,
    "vtkPSurfaceLICInterface",
 &PyvtkPSurfaceLICInterface_StaticNew);

  PyTypeObject *pytype = &PyvtkPSurfaceLICInterface_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSurfaceLICInterface_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPSurfaceLICInterface(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPSurfaceLICInterface_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPSurfaceLICInterface", o) != 0)
  {
    Py_DECREF(o);
  }

}

