#include "vtkModuleDependencies.h"

struct vtkModuleDependency
{
  const char* ModuleName;
  const char** LibraryNames;
  const char** Depends;
  bool Python;
} vtkModules[] = {
  { "vtkkwiml", vtkkwimlLibraries, vtkkwimlDepends, false },
  { "vtksys", vtksysLibraries, vtksysDepends, false },
  { "vtkutf8", vtkutf8Libraries, vtkutf8Depends, false },
  { "vtkCommonCore", vtkCommonCoreLibraries, vtkCommonCoreDepends, true },
  { "vtkPython", vtkPythonLibraries, vtkPythonDepends, false },
  { "CinemaPython", CinemaPythonLibraries, CinemaPythonDepends, false },
  { "Pygments", PygmentsLibraries, PygmentsDepends, false },
  { "vtkCommonMath", vtkCommonMathLibraries, vtkCommonMathDepends, true },
  { "vtkCommonMisc", vtkCommonMiscLibraries, vtkCommonMiscDepends, true },
  { "vtkCommonSystem", vtkCommonSystemLibraries, vtkCommonSystemDepends, true },
  { "vtkCommonTransforms", vtkCommonTransformsLibraries, vtkCommonTransformsDepends, true },
  { "vtkCommonDataModel", vtkCommonDataModelLibraries, vtkCommonDataModelDepends, true },
  { "vtkCommonExecutionModel", vtkCommonExecutionModelLibraries, vtkCommonExecutionModelDepends, true },
  { "vtkFiltersCore", vtkFiltersCoreLibraries, vtkFiltersCoreDepends, true },
  { "vtkdoubleconversion", vtkdoubleconversionLibraries, vtkdoubleconversionDepends, false },
  { "vtklz4", vtklz4Libraries, vtklz4Depends, false },
  { "vtklzma", vtklzmaLibraries, vtklzmaDepends, false },
  { "vtkzlib", vtkzlibLibraries, vtkzlibDepends, false },
  { "vtkIOCore", vtkIOCoreLibraries, vtkIOCoreDepends, true },
  { "vtkexpat", vtkexpatLibraries, vtkexpatDepends, false },
  { "vtkIOXMLParser", vtkIOXMLParserLibraries, vtkIOXMLParserDepends, true },
  { "vtkIOXML", vtkIOXMLLibraries, vtkIOXMLDepends, true },
  { "vtkIOLegacy", vtkIOLegacyLibraries, vtkIOLegacyDepends, true },
  { "vtkParallelCore", vtkParallelCoreLibraries, vtkParallelCoreDepends, true },
  { "vtkFiltersAMR", vtkFiltersAMRLibraries, vtkFiltersAMRDepends, true },
  { "vtkCommonComputationalGeometry", vtkCommonComputationalGeometryLibraries, vtkCommonComputationalGeometryDepends, true },
  { "vtkFiltersGeneral", vtkFiltersGeneralLibraries, vtkFiltersGeneralDepends, true },
  { "vtkImagingCore", vtkImagingCoreLibraries, vtkImagingCoreDepends, true },
  { "vtkImagingFourier", vtkImagingFourierLibraries, vtkImagingFourierDepends, true },
  { "vtkeigen", vtkeigenLibraries, vtkeigenDepends, false },
  { "vtkFiltersStatistics", vtkFiltersStatisticsLibraries, vtkFiltersStatisticsDepends, true },
  { "vtkFiltersExtraction", vtkFiltersExtractionLibraries, vtkFiltersExtractionDepends, true },
  { "vtkFiltersGeometry", vtkFiltersGeometryLibraries, vtkFiltersGeometryDepends, true },
  { "vtkFiltersSources", vtkFiltersSourcesLibraries, vtkFiltersSourcesDepends, true },
  { "vtkFiltersFlowPaths", vtkFiltersFlowPathsLibraries, vtkFiltersFlowPathsDepends, true },
  { "vtkDICOMParser", vtkDICOMParserLibraries, vtkDICOMParserDepends, false },
  { "vtkMetaIO", vtkMetaIOLibraries, vtkMetaIODepends, false },
  { "vtkjpeg", vtkjpegLibraries, vtkjpegDepends, false },
  { "vtkpng", vtkpngLibraries, vtkpngDepends, false },
  { "vtktiff", vtktiffLibraries, vtktiffDepends, false },
  { "vtkIOImage", vtkIOImageLibraries, vtkIOImageDepends, true },
  { "vtkIOGeometry", vtkIOGeometryLibraries, vtkIOGeometryDepends, true },
  { "vtkImagingHybrid", vtkImagingHybridLibraries, vtkImagingHybridDepends, true },
  { "vtkCommonColor", vtkCommonColorLibraries, vtkCommonColorDepends, true },
  { "vtkRenderingCore", vtkRenderingCoreLibraries, vtkRenderingCoreDepends, true },
  { "vtkImagingMath", vtkImagingMathLibraries, vtkImagingMathDepends, true },
  { "vtkglew", vtkglewLibraries, vtkglewDepends, false },
  { "vtkRenderingOpenGL2", vtkRenderingOpenGL2Libraries, vtkRenderingOpenGL2Depends, true },
  { "vtkRenderingVolume", vtkRenderingVolumeLibraries, vtkRenderingVolumeDepends, true },
  { "vtkRenderingVolumeOpenGL2", vtkRenderingVolumeOpenGL2Libraries, vtkRenderingVolumeOpenGL2Depends, true },
  { "VisItLib", VisItLibLibraries, VisItLibDepends, false },
  { "vtkInteractionStyle", vtkInteractionStyleLibraries, vtkInteractionStyleDepends, true },
  { "vtkGUISupportQt", vtkGUISupportQtLibraries, vtkGUISupportQtDepends, false },
  { "vtkFiltersModeling", vtkFiltersModelingLibraries, vtkFiltersModelingDepends, true },
  { "vtkFiltersParallel", vtkFiltersParallelLibraries, vtkFiltersParallelDepends, true },
  { "vtkFiltersProgrammable", vtkFiltersProgrammableLibraries, vtkFiltersProgrammableDepends, true },
  { "vtkPythonInterpreter", vtkPythonInterpreterLibraries, vtkPythonInterpreterDepends, true },
  { "vtkWrappingTools", vtkWrappingToolsLibraries, vtkWrappingToolsDepends, false },
  { "vtkWrappingPythonCore", vtkWrappingPythonCoreLibraries, vtkWrappingPythonCoreDepends, false },
  { "vtkClientServer", vtkClientServerLibraries, vtkClientServerDepends, true },
  { "vtkPVCommon", vtkPVCommonLibraries, vtkPVCommonDepends, true },
  { "vtkjsoncpp", vtkjsoncppLibraries, vtkjsoncppDepends, false },
  { "vtkPVVTKExtensionsCore", vtkPVVTKExtensionsCoreLibraries, vtkPVVTKExtensionsCoreDepends, true },
  { "vtkpugixml", vtkpugixmlLibraries, vtkpugixmlDepends, false },
  { "vtkPVVTKExtensionsSIL", vtkPVVTKExtensionsSILLibraries, vtkPVVTKExtensionsSILDepends, true },
  { "vtkParallelMPI", vtkParallelMPILibraries, vtkParallelMPIDepends, true },
  { "vtkUtilitiesWrapClientServer", vtkUtilitiesWrapClientServerLibraries, vtkUtilitiesWrapClientServerDepends, false },
  { "vtkPVClientServerCoreCore", vtkPVClientServerCoreCoreLibraries, vtkPVClientServerCoreCoreDepends, true },
  { "vtkprotobuf", vtkprotobufLibraries, vtkprotobufDepends, false },
  { "vtkPVServerImplementationCore", vtkPVServerImplementationCoreLibraries, vtkPVServerImplementationCoreDepends, true },
  { "vtkPVServerManagerCore", vtkPVServerManagerCoreLibraries, vtkPVServerManagerCoreDepends, true },
  { "vtkqttesting", vtkqttestingLibraries, vtkqttestingDepends, false },
  { "pqWidgets", pqWidgetsLibraries, pqWidgetsDepends, false },
  { "vtkogg", vtkoggLibraries, vtkoggDepends, false },
  { "vtktheora", vtktheoraLibraries, vtktheoraDepends, false },
  { "vtkIOMovie", vtkIOMovieLibraries, vtkIOMovieDepends, true },
  { "vtkInfovisCore", vtkInfovisCoreLibraries, vtkInfovisCoreDepends, true },
  { "vtklibxml2", vtklibxml2Libraries, vtklibxml2Depends, false },
  { "vtkIOInfovis", vtkIOInfovisLibraries, vtkIOInfovisDepends, true },
  { "vtkVTKm", vtkVTKmLibraries, vtkVTKmDepends, false },
  { "vtkAcceleratorsVTKm", vtkAcceleratorsVTKmLibraries, vtkAcceleratorsVTKmDepends, true },
  { "vtkDomainsChemistry", vtkDomainsChemistryLibraries, vtkDomainsChemistryDepends, true },
  { "vtkfreetype", vtkfreetypeLibraries, vtkfreetypeDepends, false },
  { "vtkRenderingFreeType", vtkRenderingFreeTypeLibraries, vtkRenderingFreeTypeDepends, true },
  { "vtkRenderingContext2D", vtkRenderingContext2DLibraries, vtkRenderingContext2DDepends, true },
  { "vtkChartsCore", vtkChartsCoreLibraries, vtkChartsCoreDepends, true },
  { "vtkFiltersParallelFlowPaths", vtkFiltersParallelFlowPathsLibraries, vtkFiltersParallelFlowPathsDepends, true },
  { "vtkFiltersParallelStatistics", vtkFiltersParallelStatisticsLibraries, vtkFiltersParallelStatisticsDepends, true },
  { "vtkIOEnSight", vtkIOEnSightLibraries, vtkIOEnSightDepends, true },
  { "vtkIOImport", vtkIOImportLibraries, vtkIOImportDepends, true },
  { "vtkIOMPIImage", vtkIOMPIImageLibraries, vtkIOMPIImageDepends, true },
  { "vtkIOPLY", vtkIOPLYLibraries, vtkIOPLYDepends, true },
  { "vtkhdf5", vtkhdf5Libraries, vtkhdf5Depends, false },
  { "vtknetcdf", vtknetcdfLibraries, vtknetcdfDepends, false },
  { "vtknetcdfcpp", vtknetcdfcppLibraries, vtknetcdfcppDepends, false },
  { "vtkIONetCDF", vtkIONetCDFLibraries, vtkIONetCDFDepends, true },
  { "vtkexodusII", vtkexodusIILibraries, vtkexodusIIDepends, false },
  { "vtkIOParallel", vtkIOParallelLibraries, vtkIOParallelDepends, true },
  { "vtkIOExodus", vtkIOExodusLibraries, vtkIOExodusDepends, true },
  { "vtkIOParallelExodus", vtkIOParallelExodusLibraries, vtkIOParallelExodusDepends, true },
  { "vtkIOParallelXML", vtkIOParallelXMLLibraries, vtkIOParallelXMLDepends, true },
  { "vtkImagingSources", vtkImagingSourcesLibraries, vtkImagingSourcesDepends, true },
  { "vtkFiltersHybrid", vtkFiltersHybridLibraries, vtkFiltersHybridDepends, true },
  { "vtkImagingColor", vtkImagingColorLibraries, vtkImagingColorDepends, true },
  { "vtkImagingGeneral", vtkImagingGeneralLibraries, vtkImagingGeneralDepends, true },
  { "vtkRenderingAnnotation", vtkRenderingAnnotationLibraries, vtkRenderingAnnotationDepends, true },
  { "vtkInteractionWidgets", vtkInteractionWidgetsLibraries, vtkInteractionWidgetsDepends, true },
  { "vtkFiltersGeneric", vtkFiltersGenericLibraries, vtkFiltersGenericDepends, true },
  { "vtkFiltersHyperTree", vtkFiltersHyperTreeLibraries, vtkFiltersHyperTreeDepends, true },
  { "vtkFiltersParallelMPI", vtkFiltersParallelMPILibraries, vtkFiltersParallelMPIDepends, true },
  { "vtkgl2ps", vtkgl2psLibraries, vtkgl2psDepends, false },
  { "vtkRenderingGL2PSOpenGL2", vtkRenderingGL2PSOpenGL2Libraries, vtkRenderingGL2PSOpenGL2Depends, true },
  { "vtkIOExport", vtkIOExportLibraries, vtkIOExportDepends, true },
  { "vtkIOExportOpenGL2", vtkIOExportOpenGL2Libraries, vtkIOExportOpenGL2Depends, true },
  { "vtkRenderingContextOpenGL2", vtkRenderingContextOpenGL2Libraries, vtkRenderingContextOpenGL2Depends, true },
  { "vtkRenderingMatplotlib", vtkRenderingMatplotlibLibraries, vtkRenderingMatplotlibDepends, true },
  { "vtkRenderingParallel", vtkRenderingParallelLibraries, vtkRenderingParallelDepends, true },
  { "vtkRenderingVolumeAMR", vtkRenderingVolumeAMRLibraries, vtkRenderingVolumeAMRDepends, true },
  { "vtkicet", vtkicetLibraries, vtkicetDepends, false },
  { "vtkPVVTKExtensionsRendering", vtkPVVTKExtensionsRenderingLibraries, vtkPVVTKExtensionsRenderingDepends, true },
  { "vtkPVVTKExtensionsDefault", vtkPVVTKExtensionsDefaultLibraries, vtkPVVTKExtensionsDefaultDepends, true },
  { "vtkRenderingLabel", vtkRenderingLabelLibraries, vtkRenderingLabelDepends, true },
  { "vtkViewsCore", vtkViewsCoreLibraries, vtkViewsCoreDepends, true },
  { "vtkViewsContext2D", vtkViewsContext2DLibraries, vtkViewsContext2DDepends, true },
  { "vtkPVClientServerCoreRendering", vtkPVClientServerCoreRenderingLibraries, vtkPVClientServerCoreRenderingDepends, true },
  { "vtkPVClientServerCoreDefault", vtkPVClientServerCoreDefaultLibraries, vtkPVClientServerCoreDefaultDepends, true },
  { "vtkPVServerImplementationRendering", vtkPVServerImplementationRenderingLibraries, vtkPVServerImplementationRenderingDepends, true },
  { "vtkUtilitiesProcessXML", vtkUtilitiesProcessXMLLibraries, vtkUtilitiesProcessXMLDepends, false },
  { "vtkPVServerManagerRendering", vtkPVServerManagerRenderingLibraries, vtkPVServerManagerRenderingDepends, true },
  { "vtkTestingCore", vtkTestingCoreLibraries, vtkTestingCoreDepends, false },
  { "vtkTestingRendering", vtkTestingRenderingLibraries, vtkTestingRenderingDepends, true },
  { "vtkPVServerManagerDefault", vtkPVServerManagerDefaultLibraries, vtkPVServerManagerDefaultDepends, true },
  { "vtkPVAnimation", vtkPVAnimationLibraries, vtkPVAnimationDepends, true },
  { "vtkDomainsChemistryOpenGL2", vtkDomainsChemistryOpenGL2Libraries, vtkDomainsChemistryOpenGL2Depends, true },
  { "vtkDomainsParallelChemistry", vtkDomainsParallelChemistryLibraries, vtkDomainsParallelChemistryDepends, true },
  { "vtkdiy2", vtkdiy2Libraries, vtkdiy2Depends, false },
  { "vtkFiltersParallelDIY2", vtkFiltersParallelDIY2Libraries, vtkFiltersParallelDIY2Depends, true },
  { "vtkFiltersParallelGeometry", vtkFiltersParallelGeometryLibraries, vtkFiltersParallelGeometryDepends, true },
  { "vtkFiltersImaging", vtkFiltersImagingLibraries, vtkFiltersImagingDepends, true },
  { "vtkFiltersParallelImaging", vtkFiltersParallelImagingLibraries, vtkFiltersParallelImagingDepends, true },
  { "vtkverdict", vtkverdictLibraries, vtkverdictDepends, false },
  { "vtkFiltersVerdict", vtkFiltersVerdictLibraries, vtkFiltersVerdictDepends, true },
  { "vtkFiltersParallelVerdict", vtkFiltersParallelVerdictLibraries, vtkFiltersParallelVerdictDepends, true },
  { "vtkFiltersPython", vtkFiltersPythonLibraries, vtkFiltersPythonDepends, true },
  { "vtkFiltersTexture", vtkFiltersTextureLibraries, vtkFiltersTextureDepends, true },
  { "vtkIOAMR", vtkIOAMRLibraries, vtkIOAMRDepends, true },
  { "vtkIOAsynchronous", vtkIOAsynchronousLibraries, vtkIOAsynchronousDepends, true },
  { "vtkIOMPIParallel", vtkIOMPIParallelLibraries, vtkIOMPIParallelDepends, true },
  { "vtkpegtl", vtkpegtlLibraries, vtkpegtlDepends, false },
  { "vtkIOMotionFX", vtkIOMotionFXLibraries, vtkIOMotionFXDepends, true },
  { "vtkIOLSDyna", vtkIOLSDynaLibraries, vtkIOLSDynaDepends, true },
  { "vtkIOParallelLSDyna", vtkIOParallelLSDynaLibraries, vtkIOParallelLSDynaDepends, true },
  { "vtkIOParallelNetCDF", vtkIOParallelNetCDFLibraries, vtkIOParallelNetCDFDepends, true },
  { "vtkIOSegY", vtkIOSegYLibraries, vtkIOSegYDepends, true },
  { "vtkIOTRUCHAS", vtkIOTRUCHASLibraries, vtkIOTRUCHASDepends, true },
  { "vtkIOTecplotTable", vtkIOTecplotTableLibraries, vtkIOTecplotTableDepends, true },
  { "vtkVPIC", vtkVPICLibraries, vtkVPICDepends, false },
  { "vtkIOVPIC", vtkIOVPICLibraries, vtkIOVPICDepends, true },
  { "vtkIOVeraOut", vtkIOVeraOutLibraries, vtkIOVeraOutDepends, true },
  { "vtkIOVisItBridge", vtkIOVisItBridgeLibraries, vtkIOVisItBridgeDepends, true },
  { "vtkxdmf2", vtkxdmf2Libraries, vtkxdmf2Depends, false },
  { "vtkIOXdmf2", vtkIOXdmf2Libraries, vtkIOXdmf2Depends, true },
  { "vtkImagingMorphological", vtkImagingMorphologicalLibraries, vtkImagingMorphologicalDepends, true },
  { "vtkInteractionImage", vtkInteractionImageLibraries, vtkInteractionImageDepends, true },
  { "vtkPVCinemaReader", vtkPVCinemaReaderLibraries, vtkPVCinemaReaderDepends, true },
  { "vtkPVPythonAlgorithm", vtkPVPythonAlgorithmLibraries, vtkPVPythonAlgorithmDepends, true },
  { "vtkcgns", vtkcgnsLibraries, vtkcgnsDepends, false },
  { "vtkPVVTKExtensionsCGNSReader", vtkPVVTKExtensionsCGNSReaderLibraries, vtkPVVTKExtensionsCGNSReaderDepends, true },
  { "vtkPVVTKExtensionsCGNSWriter", vtkPVVTKExtensionsCGNSWriterLibraries, vtkPVVTKExtensionsCGNSWriterDepends, true },
  { "vtkPVVTKExtensionsH5PartReader", vtkPVVTKExtensionsH5PartReaderLibraries, vtkPVVTKExtensionsH5PartReaderDepends, true },
  { "vtkFiltersPoints", vtkFiltersPointsLibraries, vtkFiltersPointsDepends, true },
  { "vtkPVVTKExtensionsPoints", vtkPVVTKExtensionsPointsLibraries, vtkPVVTKExtensionsPointsDepends, true },
  { "vtkmpi4py", vtkmpi4pyLibraries, vtkmpi4pyDepends, false },
  { "vtkParallelMPI4Py", vtkParallelMPI4PyLibraries, vtkParallelMPI4PyDepends, true },
  { "vtkRenderingLICOpenGL2", vtkRenderingLICOpenGL2Libraries, vtkRenderingLICOpenGL2Depends, true },
  { "vtkRenderingLOD", vtkRenderingLODLibraries, vtkRenderingLODDepends, true },
  { "vtkRenderingParallelLIC", vtkRenderingParallelLICLibraries, vtkRenderingParallelLICDepends, true },
  { "vtkPVServerManagerApplication", vtkPVServerManagerApplicationLibraries, vtkPVServerManagerApplicationDepends, true },
  { "pqCore", pqCoreLibraries, pqCoreDepends, false },
  { "pqPython", pqPythonLibraries, pqPythonDepends, false },
  { "pqComponents", pqComponentsLibraries, pqComponentsDepends, false },
  { "vtkUtilitiesLegacyColorMapXMLToJSON", vtkUtilitiesLegacyColorMapXMLToJSONLibraries, vtkUtilitiesLegacyColorMapXMLToJSONDepends, false },
  { "pqApplicationComponents", pqApplicationComponentsLibraries, pqApplicationComponentsDepends, false },
  { "smTestDriver", smTestDriverLibraries, smTestDriverDepends, false },
  { "vtkPVCatalyst", vtkPVCatalystLibraries, vtkPVCatalystDepends, true },
  { "vtkWebGLExporter", vtkWebGLExporterLibraries, vtkWebGLExporterDepends, true },
  { "vtkWebCore", vtkWebCoreLibraries, vtkWebCoreDepends, true },
  { "vtkParaViewWebCore", vtkParaViewWebCoreLibraries, vtkParaViewWebCoreDepends, true },
  { "vtkParaViewWebPython", vtkParaViewWebPythonLibraries, vtkParaViewWebPythonDepends, false },
  { "vtkWebPython", vtkWebPythonLibraries, vtkWebPythonDepends, false },
  { "vtkParaViewWeb", vtkParaViewWebLibraries, vtkParaViewWebDepends, false },
  { "vtkPVPythonCatalyst", vtkPVPythonCatalystLibraries, vtkPVPythonCatalystDepends, true },
  { "vtkUtilitiesPythonInitializer", vtkUtilitiesPythonInitializerLibraries, vtkUtilitiesPythonInitializerDepends, false },
  { NULL, NULL, NULL, false }
};
