// python wrapper for vtkPSurfaceLICComposite
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTextureObject.h"
#include "vtkPSurfaceLICComposite.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPSurfaceLICComposite(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPSurfaceLICComposite_ClassNew(); }

#ifndef DECLARED_PyvtkSurfaceLICComposite_ClassNew
extern "C" { PyObject *PyvtkSurfaceLICComposite_ClassNew(); }
#define DECLARED_PyvtkSurfaceLICComposite_ClassNew
#endif

static const char *PyvtkPSurfaceLICComposite_Doc =
  "vtkPSurfaceLICComposite - This class decomposes the image space and\nshuffles image space data onto the new decomposition with the\nnecessary guard cells to prevent artifacts at the decomposition\nboundaries.\n\n"
  "Superclass: vtkSurfaceLICComposite\n\n"
  "After the image LIC is computed on the new decomposition this class\n"
  "will un-shuffle the computed LIC back onto the original\n"
  "decomposition.\n\n";


static PyObject *
PyvtkPSurfaceLICComposite_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPSurfaceLICComposite::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICComposite_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICComposite *op = static_cast<vtkPSurfaceLICComposite *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPSurfaceLICComposite::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICComposite_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPSurfaceLICComposite *tempr = vtkPSurfaceLICComposite::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICComposite_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICComposite *op = static_cast<vtkPSurfaceLICComposite *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPSurfaceLICComposite *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPSurfaceLICComposite::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICComposite_SetContext(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetContext");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICComposite *op = static_cast<vtkPSurfaceLICComposite *>(vp);

  vtkOpenGLRenderWindow *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkOpenGLRenderWindow"))
  {
    if (ap.IsBound())
    {
      op->SetContext(temp0);
    }
    else
    {
      op->vtkPSurfaceLICComposite::SetContext(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICComposite_GetContext(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContext");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICComposite *op = static_cast<vtkPSurfaceLICComposite *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLRenderWindow *tempr = (ap.IsBound() ?
      op->GetContext() :
      op->vtkPSurfaceLICComposite::GetContext());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPSurfaceLICComposite_BuildProgram(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BuildProgram");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPSurfaceLICComposite *op = static_cast<vtkPSurfaceLICComposite *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->BuildProgram(temp0) :
      op->vtkPSurfaceLICComposite::BuildProgram(temp0));

    if (ap.HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPSurfaceLICComposite_Methods[] = {
  {"IsTypeOf", PyvtkPSurfaceLICComposite_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPSurfaceLICComposite_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPSurfaceLICComposite_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPSurfaceLICComposite\nC++: static vtkPSurfaceLICComposite *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPSurfaceLICComposite_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPSurfaceLICComposite\nC++: vtkPSurfaceLICComposite *NewInstance()\n\n"},
  {"SetContext", PyvtkPSurfaceLICComposite_SetContext, METH_VARARGS,
   "V.SetContext(vtkOpenGLRenderWindow)\nC++: virtual void SetContext(vtkOpenGLRenderWindow *rwin)\n    override;\n\nSet the rendering context. Must set prior to use. Reference is\nnot held, so caller must ensure the renderer is not destroyed\nduring use.\n"},
  {"GetContext", PyvtkPSurfaceLICComposite_GetContext, METH_VARARGS,
   "V.GetContext() -> vtkOpenGLRenderWindow\nC++: virtual vtkOpenGLRenderWindow *GetContext() override;\n\n"},
  {"BuildProgram", PyvtkPSurfaceLICComposite_BuildProgram, METH_VARARGS,
   "V.BuildProgram([float, ...]) -> int\nC++: virtual int BuildProgram(float *vectors) override;\n\nBuild programs to move data to the new decomp THIS IS A\nCOLLECTIVE OPERATION\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPSurfaceLICComposite_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingParallelLICPython.vtkPSurfaceLICComposite", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPSurfaceLICComposite_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPSurfaceLICComposite_StaticNew()
{
  return vtkPSurfaceLICComposite::New();
}

PyObject *PyvtkPSurfaceLICComposite_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPSurfaceLICComposite_Type, PyvtkPSurfaceLICComposite_Methods,
    "vtkPSurfaceLICComposite",
 &PyvtkPSurfaceLICComposite_StaticNew);

  PyTypeObject *pytype = &PyvtkPSurfaceLICComposite_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSurfaceLICComposite_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPSurfaceLICComposite(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPSurfaceLICComposite_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPSurfaceLICComposite", o) != 0)
  {
    Py_DECREF(o);
  }

}

