/* #undef PARAVIEW_USE_UNIFIED_BINDINGS */
/* #undef NO_PYTHON_BINDINGS_AVAILABLE */
#ifdef NO_PYTHON_BINDINGS_AVAILABLE
#undef PARAVIEW_USE_UNIFIED_BINDINGS
#endif
#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
#include "vtkPython.h"
#include "vtkPythonInterpreter.h"
#endif

#include "vtkClientServerInterpreter.h"

#ifndef PARAVIEW_BUILD_SHARED_LIBS
#define PARAVIEW_BUILD_SHARED_LIBS
#endif
#if defined(PARAVIEW_BUILD_SHARED_LIBS) && defined(_WIN32)
# define VTK_WRAP_CS_EXPORT __declspec(dllexport)
#else
# define VTK_WRAP_CS_EXPORT
#endif

#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
extern "C" void real_initvtkIOMPIImagePython(const char *modulename);

void initvtkIOMPIImagePython()
{
  static const char modulename[] = "vtkIOMPIImagePython";
  real_initvtkIOMPIImagePython(modulename);
}
#endif

extern void vtkPNrrdReader_Init(vtkClientServerInterpreter* csi);
extern void vtkMPIImageReader_Init(vtkClientServerInterpreter* csi);
extern void vtkIOMPIImageObjectFactory_Init(vtkClientServerInterpreter* csi);


extern "C" void VTK_WRAP_CS_EXPORT vtkIOMPIImageCS_Initialize(
  vtkClientServerInterpreter *csi)
{
  // silence unreferenced var warning.
  (void) csi;

#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
  if (!vtkPythonInterpreter::IsInitialized())
    {
    vtkPythonInterpreter::Initialize();
    }

  static bool initialized = false;

  if (!initialized)
    {
    initialized = true;
    PyImport_AppendInittab("vtkIOMPIImagePython", initvtkIOMPIImagePython);
    }

  csi->Load("vtkIOMPIImage");
#endif

  vtkPNrrdReader_Init(csi);
  vtkMPIImageReader_Init(csi);
  vtkIOMPIImageObjectFactory_Init(csi);

}
