/*****************************************************************************
*
* Copyright (c) 2000 - 2017, Lawrence Livermore National Security, LLC
* Produced at the Lawrence Livermore National Laboratory
* LLNL-CODE-442911
* All rights reserved.
*
* This file is  part of VisIt. For  details, see https://visit.llnl.gov/.  The
* full copyright notice is contained in the file COPYRIGHT located at the root
* of the VisIt distribution or at http://www.llnl.gov/visit/copyright.html.
*
* Redistribution  and  use  in  source  and  binary  forms,  with  or  without
* modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of  source code must  retain the above  copyright notice,
*    this list of conditions and the disclaimer below.
*  - Redistributions in binary form must reproduce the above copyright notice,
*    this  list of  conditions  and  the  disclaimer (as noted below)  in  the
*    documentation and/or other materials provided with the distribution.
*  - Neither the name of  the LLNS/LLNL nor the names of  its contributors may
*    be used to endorse or promote products derived from this software without
*    specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR  IMPLIED WARRANTIES, INCLUDING,  BUT NOT  LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND  FITNESS FOR A PARTICULAR  PURPOSE
* ARE  DISCLAIMED. IN  NO EVENT  SHALL LAWRENCE  LIVERMORE NATIONAL  SECURITY,
* LLC, THE  U.S.  DEPARTMENT OF  ENERGY  OR  CONTRIBUTORS BE  LIABLE  FOR  ANY
* DIRECT,  INDIRECT,   INCIDENTAL,   SPECIAL,   EXEMPLARY,  OR   CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT  LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR
* SERVICES; LOSS OF  USE, DATA, OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER
* CAUSED  AND  ON  ANY  THEORY  OF  LIABILITY,  WHETHER  IN  CONTRACT,  STRICT
* LIABILITY, OR TORT  (INCLUDING NEGLIGENCE OR OTHERWISE)  ARISING IN ANY  WAY
* OUT OF THE  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
* DAMAGE.
*
*****************************************************************************/
#include <ConfigureInfo.h>

//
// This file is automatically generated by CMake. DO NOT EDIT!
//
namespace visitcommon {

std::string
Version()
{
#define VISIT_VERSION "2.7.0"
#ifdef VISIT_VERSION
     return VISIT_VERSION;
#else
     return "2.0";
#endif
}

std::string 
SVNVersion()
{
/* #undef VISIT_SVN_REVISION */
#ifdef VISIT_SVN_REVISION
    return std::string(VISIT_SVN_REVISION);
#else
    return std::string("");
#endif
}

std::string
VersionControlVersionString()
{
/* #undef VISIT_VERSION_STRING */
#ifdef VISIT_VERSION_STRING
    return std::string(VISIT_VERSION_STRING);
#else
    return std::string("svn version ") + SVNVersion();
#endif
}

std::string
SlashString()
{
#ifdef WIN32
    return "\\";
#else
    return "/";
#endif
}

char 
SlashChar()
{
#ifdef WIN32
    return '\\';
#else
    return '/';
#endif  
}

std::string
PluginExtension()
{
#ifdef WIN32
     return ".dll";
#elif defined(__APPLE__)
     return ".dylib";
#else
     return ".so";
#endif
}

int
RenderingSizeLimit()
{
/* #undef VISIT_RENDERING_SIZE_LIMIT */
#ifdef VISIT_RENDERING_SIZE_LIMIT
    return VISIT_RENDERING_SIZE_LIMIT;
#else
    return 4096;
#endif
}

};
