// python wrapper for vtkTDxInteractorStyleCamera
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTDxInteractorStyleCamera.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTDxInteractorStyleCamera(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTDxInteractorStyleCamera_ClassNew(); }

#ifndef DECLARED_PyvtkTDxInteractorStyle_ClassNew
extern "C" { PyObject *PyvtkTDxInteractorStyle_ClassNew(); }
#define DECLARED_PyvtkTDxInteractorStyle_ClassNew
#endif

static const char *PyvtkTDxInteractorStyleCamera_Doc =
  "vtkTDxInteractorStyleCamera - interactive manipulation of the camera\nwith a 3DConnexion device\n\n"
  "Superclass: vtkTDxInteractorStyle\n\n"
  "vtkTDxInteractorStyleCamera allows the end-user to manipulate tha\n"
  "camera with a 3DConnexion device.\n\n"
  "@sa\n"
  "vtkInteractorStyle vtkRenderWindowInteractor vtkTDxInteractorStyle\n\n";


static PyObject *
PyvtkTDxInteractorStyleCamera_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkTDxInteractorStyleCamera::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTDxInteractorStyleCamera_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTDxInteractorStyleCamera *op = static_cast<vtkTDxInteractorStyleCamera *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTDxInteractorStyleCamera::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTDxInteractorStyleCamera_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkTDxInteractorStyleCamera *tempr = vtkTDxInteractorStyleCamera::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTDxInteractorStyleCamera_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTDxInteractorStyleCamera *op = static_cast<vtkTDxInteractorStyleCamera *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkTDxInteractorStyleCamera *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTDxInteractorStyleCamera::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTDxInteractorStyleCamera_OnMotionEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMotionEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTDxInteractorStyleCamera *op = static_cast<vtkTDxInteractorStyleCamera *>(vp);

  vtkTDxMotionEventInfo *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTDxMotionEventInfo"))
  {
    if (ap.IsBound())
    {
      op->OnMotionEvent(temp0);
    }
    else
    {
      op->vtkTDxInteractorStyleCamera::OnMotionEvent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkTDxInteractorStyleCamera_Methods[] = {
  {"IsTypeOf", PyvtkTDxInteractorStyleCamera_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkTDxInteractorStyleCamera_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkTDxInteractorStyleCamera_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkTDxInteractorStyleCamera\nC++: static vtkTDxInteractorStyleCamera *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkTDxInteractorStyleCamera_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTDxInteractorStyleCamera\nC++: vtkTDxInteractorStyleCamera *NewInstance()\n\n"},
  {"OnMotionEvent", PyvtkTDxInteractorStyleCamera_OnMotionEvent, METH_VARARGS,
   "V.OnMotionEvent(vtkTDxMotionEventInfo)\nC++: void OnMotionEvent(vtkTDxMotionEventInfo *motionInfo)\n    override;\n\nAction on motion event.\n\\pre: motionInfo_exist: motionInfo!=0\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkTDxInteractorStyleCamera_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkTDxInteractorStyleCamera", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkTDxInteractorStyleCamera_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTDxInteractorStyleCamera_StaticNew()
{
  return vtkTDxInteractorStyleCamera::New();
}

PyObject *PyvtkTDxInteractorStyleCamera_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTDxInteractorStyleCamera_Type, PyvtkTDxInteractorStyleCamera_Methods,
    "vtkTDxInteractorStyleCamera",
 &PyvtkTDxInteractorStyleCamera_StaticNew);

  PyTypeObject *pytype = &PyvtkTDxInteractorStyleCamera_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTDxInteractorStyle_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkTDxInteractorStyleCamera(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTDxInteractorStyleCamera_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTDxInteractorStyleCamera", o) != 0)
  {
    Py_DECREF(o);
  }

}

